package com.gxwebsoft.common.system.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.Area;
import com.gxwebsoft.common.system.param.AreaParam;

import java.util.List;

/**
 * Service
 *
 * @author 科技小王子
 * @since 2023-07-06 15:08:15
 */
public interface AreaService extends IService<Area> {

    /**
     * 分页关联查询
     *
     * @param param 查询参数
     * @return PageResult<Area>
     */
    PageResult<Area> pageRel(AreaParam param);

    /**
     * 关联查询全部
     *
     * @param param 查询参数
     * @return List<Area>
     */
    List<Area> listRel(AreaParam param);

    /**
     * 根据id查询
     *
     * @param id 
     * @return Area
     */
    Area getByIdRel(Integer id);

    Area areaInfoByName(String name, Integer level);

    Area areaInfoByName(String name, Integer level, Integer parentId);

    Area regionInfoWithProvince(String provinceName, String cityName, String regionName);
}
